#pragma semicolon 1

#include <sourcemod>
#include <vip>
#include <sdktools>

public Plugin:myinfo = 
{
	name	= "VIP Module (AutoSilencer)",
	author	= "Tokami",
	version = "1.0"
};

new const String:g_sItemName[] = "auto_silencer";
new g_ItemID;
new bool:g_bAccess[MAXPLAYERS + 1];
new g_SilencerOn;

public OnPluginStart()
{
	if ((g_ItemID = VIP_RegisterItem(g_sItemName, true, true)) < 1)
		SetFailState("VIP_RegisterItem error");
	
	g_SilencerOn = FindSendPropOffs("CWeaponM4A1", "m_bSilencerOn");
	HookEvent("item_pickup", EventItemPickup);
}

public OnPluginEnd()
{
	VIP_UnRegisterItem(g_sItemName);
}

public OnClientConnected(client)
{
	g_bAccess[client] = false;
}

public VIP_OnClientAuthorized(client, const String:steamid[], bool:vip, const String:group[])
{
	if (vip) wS_Check(client);
}

public VIP_OnVipItemToggled(client, ItemID, const String:ItemName[], const String:ItemInfo[], bool:enabled)
{
	if (ItemID == g_ItemID)
	{
		g_bAccess[client] = enabled;
		VIP_ShowMenu(client);
	}
}

public VIP_OnRemoved(client, const String:steamid[], const String:reason[])
{
	g_bAccess[client] = false;
}

public VIP_OnGroupChanged(client, const String:steamid[], const String:OldGroup[], const String:NewGroup[])
{
	g_bAccess[client] = false;
	wS_Check(client);
}

public VIP_OnAdded(client, const String:steamid[], const String:group[], min, const String:admin_steamid[])
{
	if (client > 0) wS_Check(client);
}

wS_Check(client)
{
	if (!VIP_ItemDisabled(g_sItemName) && VIP_GetItemToggledStatus(client, g_sItemName))
	{
		decl String:ItemInfo[MAX_ITEMINFO_LENGTH];
		if (VIP_GetClientItemInfo(client, g_sItemName, ItemInfo))
		{
			g_bAccess[client] = true;
		}
	}
}

public EventItemPickup(Handle:event, const String:name[],bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(g_bAccess[client])
	{
		decl String:item[32]; GetEventString(event, "item", item, sizeof(item));
		if (StrEqual(item, "m4a1"))
		{
			new m4 = GetPlayerWeaponSlot(client, 0);
			SetEntData(m4, g_SilencerOn, 1);
		}
	}
}